#include <stdio.h>
#include <stdlib.h>

#include "stack.h"

char* char2str (char c)
{
  char *res = malloc (2 * sizeof(char));
  res[0] = c;
  res[1] = '\0';
  return res;
}

/* Find the k greatest value in an array using a max-heap */

int main (){

  int size = 7;
  char tab[] = { '3', '4', '-', '5', '+', '9', '*' };
  integer_stack_t stack;

  integer_stack_init(&stack);

  for (int i = 0; i < size; i++) {
    printf ("Element = %c\n", tab[i]);
    switch (tab[i]) {
    case '0':
    case '1':
    case '2':
    case '3':
    case '4':
    case '5':
    case '6':
    case '7':
    case '8':
    case '9':
      integer_stack_push (&stack, atoi(char2str(tab[i])));
      break;

    case '+': {
      int a;
      integer_stack_pop (&stack, &a);
      int b;
      integer_stack_pop (&stack, &b);
      integer_stack_push (&stack, b+a);
      break;
    }

    case '-': {
      int a;
      integer_stack_pop (&stack, &a);
      int b;
      integer_stack_pop (&stack, &b);
      integer_stack_push (&stack, b-a);
      break;
    }

    case '*': {
      int a;
      integer_stack_pop (&stack, &a);
      int b;
      integer_stack_pop (&stack, &b);
      integer_stack_push (&stack, b*a);
      break;
    }

    case '/': {
      int a;
      integer_stack_pop (&stack, &a);
      int b;
      integer_stack_pop (&stack, &b);
      integer_stack_push (&stack, b/a);
      break;
    }

    default:
      fprintf (stderr, "Should not happen %c!\n", tab[i]);
      return EXIT_FAILURE;
      break;

    }
  }

  int result;
  integer_stack_pop (&stack, &result);
  printf ("result = %d\n", result);

  integer_stack_destroy(&stack);

  return EXIT_SUCCESS;
}
