#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdbool.h>

#include "list.h"
#include "stack.h"

bool is_palindrome (character_list_t* str) {

  int len = character_list_size (str);
  character_stack_t stack;
  character_stack_init (&stack);

  character_list_elmt_t* c = character_list_head (str);
  int i = 0;
  while (i < len / 2) {
    char cd = character_list_data (c);
    character_stack_push (&stack, cd);
    c = character_list_next (c);
    i++;
  }
  if (len % 2 == 1) {
    /* Ne pas considerer le caractere du milieu */
    c = character_list_next (c);
    i++;
  }
  while (i < len) {
    char cs;
    character_stack_pop (&stack, &cs);
    char cd = character_list_data (c);
    if (cs != cd) {
      character_stack_destroy (&stack);
      return false;
    }
    c = character_list_next (c);
    i++;
  }

  character_stack_destroy (&stack);
  return true;
}

int main (int argc, char** argv){

  if (argc != 2) {
    printf ("Usage %s string\n", argv[0]);
    return EXIT_SUCCESS;
  }

  character_list_t lstr;
  character_list_init (&lstr);
  for (int i = 0; i < strlen(argv[1]); i++) {
    character_list_ins_next (&lstr, character_list_tail (&lstr), argv[1][i]);
  }

  bool result = is_palindrome (&lstr);

  if (result) {
    printf ("The string \"%s\" is a palindrome\n", argv[1]);
  }
  else {
    printf ("The string \"%s\" is not a palindrome\n", argv[1]);
  }

  character_list_destroy (&lstr);

  return EXIT_SUCCESS;
}
