#include <stdlib.h>
#include <stdio.h>

#include "stack.h"

typedef struct MPile_ {
  int somme;
  integer_stack_t stack;
} MPile_t;

void init (MPile_t *p) {
  p->somme = 0;
  integer_stack_init (&(p->stack));
}

void destroy (MPile_t *p) {
  p->somme = 0;
  integer_stack_destroy (&(p->stack));
}

void push (MPile_t *p, int elt) {
  p->somme += elt;
  integer_stack_push (&(p->stack), elt);
}

int pop (MPile_t *p) {
  int temp;
  integer_stack_pop (&(p->stack), &temp);
  p->somme -= temp;
  return temp;
}

double mean (MPile_t *p) {
  if (integer_stack_size (&(p->stack)) > 0) {
    return ((double)p->somme) / integer_stack_size (&(p->stack));
  }
  return 0.0;
}

int size (MPile_t *p) {
  return integer_stack_size (&(p->stack));
}

int main (int argc, char** arg) {

  MPile_t p;
  init (&p);

  for (int i = 1; i < 6; i++) {
    push (&p, i);
  }

  while (size(&p) > 0) {
    printf ("m=%f\n", mean(&p));
    int elem = pop(&p);
    printf ("Pop %d\n", elem);
  }
  printf ("\n");

  destroy(&p);

  return EXIT_SUCCESS;
}
