#include <stdio.h>
#include <stdlib.h>
#include <stdbool.h>
#include <string.h>

#include "bistree.h"
#include "bitreealg.h"
#include "list.h"

int compare (const void *a, const void *b) {
  char* sa = (char*) a;
  char* sb = (char*) b;
  return strcmp (sa, sb);
}

void* build (const void *data) {
  char* sdata = (char*) data;
  int len = strlen(data);
  char *dest = malloc((len+1) * sizeof(char)); /* Do not forget the \0 value */
  /* By default strncpy return a pointer on dest */
  return strncpy (dest, sdata, len+1); /* Do not forget the \0 value */
}

int main () {

  char* strings[5][5] = { {"wize", "students", "work", "very", "tremendously"},
			  {"beautiful", "blue", "flowers", "of", "Earth"},
			  {"great", "place", "is", "ENSTA", "Paris"},
			  {"work", "happily", "to", "be", "here"},
			  {"hard", "time", "to", "spend", "here"}
  };

  for (int i = 0; i < 5; i++) {
    generic_bistree_t tree;
    generic_bistree_init (&tree, compare, build, free);

    for (int j = 0; j < 5; j++) {
      generic_bistree_insert (&tree, strings[i][j]);
    }
    generic_list_t t_inorder;
    generic_list_init (&t_inorder, NULL, NULL, NULL);
    generic_bitreenode_t* root = generic_bitree_root (&tree);
    generic_inorder (root, &t_inorder);

    if (i % 2 == 0) {
      generic_list_elmt_t *elt = generic_list_head(&t_inorder);
      printf ("%s\n", (char*)((generic_avlnode_t *) generic_list_data(elt))->data);
    }
    else {
      generic_list_elmt_t *elt = generic_list_tail(&t_inorder);
      printf ("%s\n", (char*)((generic_avlnode_t *) generic_list_data(elt))->data);
    }

    generic_list_destroy (&t_inorder);
    generic_bistree_destroy (&tree);
  }

  return EXIT_SUCCESS;
}
