#include <stdio.h>
#include <stdlib.h>
#include <stdbool.h>

#include "graph.h"
#include "graphalg.h"
#include "list.h"

void print_graph (integer_graph_t* graph) {
  generic_list_elmt_t* elem1 =
    generic_list_head(&(graph->adjlists));
  /* Boucle sur les elements de la liste */
  for (; elem1 != NULL; elem1 = generic_list_next(elem1)) {
    integer_adjlist_t* tempV1 =
      (integer_adjlist_t*)generic_list_data(elem1);
    printf ("Vertex %d: ", tempV1->vertex);

    generic_list_elmt_t* elem2 =
      generic_list_head(&(tempV1->adjacent));
    /* Boucle sur les elements de l'ensemble (set) */
    for (; elem2 != NULL; elem2 = generic_list_next(elem2)) {
      integer_adjlist_elmt_t *tempV2 =
	(integer_adjlist_elmt_t*)generic_list_data(elem2);
      printf ("%d->", tempV2->vertex);
    }
    printf ("\n");
  }
}

int main (int argc, char** argv) {
  integer_graph_t graph;
  integer_graph_init (&graph);

  for (int i = 0; i < 9 ; i++) {
    integer_graph_ins_vertex(&graph, i);
  }
  /* The graph is not directed so we enter the edges in one direction
     and in the other direction */
  integer_graph_ins_edge(&graph, 0, 1, 6.0); integer_graph_ins_edge(&graph, 1, 0, 6.0);
  integer_graph_ins_edge(&graph, 0, 6, 6.0); integer_graph_ins_edge(&graph, 6, 0, 6.0);

  integer_graph_ins_edge(&graph, 1, 2, 9.0); integer_graph_ins_edge(&graph, 2, 1, 9.0);
  integer_graph_ins_edge(&graph, 1, 6, 6.0); integer_graph_ins_edge(&graph, 6, 1, 6.0);
  integer_graph_ins_edge(&graph, 1, 7, 20.0); integer_graph_ins_edge(&graph, 7, 1, 20.0);

  integer_graph_ins_edge(&graph, 2, 4, 2.0); integer_graph_ins_edge(&graph, 4, 2, 2.0);
  integer_graph_ins_edge(&graph, 2, 3, 6.0); integer_graph_ins_edge(&graph, 3, 2, 6.0);

  integer_graph_ins_edge(&graph, 3, 4, 10.0); integer_graph_ins_edge(&graph, 4, 3, 10.0);
  integer_graph_ins_edge(&graph, 3, 5, 5.0); integer_graph_ins_edge(&graph, 4, 5, 5.0);

  integer_graph_ins_edge(&graph, 4, 5, 12.0); integer_graph_ins_edge(&graph, 5, 4, 12.0);
  integer_graph_ins_edge(&graph, 4, 7, 1.0); integer_graph_ins_edge(&graph, 7, 4, 1.0);
  integer_graph_ins_edge(&graph, 4, 8, 5.0); integer_graph_ins_edge(&graph, 8, 4, 5.0);

  integer_graph_ins_edge(&graph, 5, 8, 12.0); integer_graph_ins_edge(&graph, 8, 5, 12.0);

  integer_graph_ins_edge(&graph, 6, 7, 1.0); integer_graph_ins_edge(&graph, 7, 6, 1.0);

  integer_graph_ins_edge(&graph, 7, 8, 2.0); integer_graph_ins_edge(&graph, 8, 7, 2.0);

  print_graph (&graph);
  printf ("\n\n");

  generic_list_t *paths;
  integer_shortest (&graph, 0, &paths);

  /* On recherche le chemin en transformant le resultat en tableau de parents */
  int* parents = malloc (9 * sizeof(int));
  if (parents == NULL) {
    generic_list_destroy (paths);
    integer_graph_destroy (&graph);
    return EXIT_FAILURE;
  }

  generic_list_elmt_t *elem = generic_list_head (paths);
  for (; elem != NULL; elem = generic_list_next (elem)) {
    ed_t* v = generic_list_data (elem);
    parents[v->vertex] = v->parent;
  }

  int u = 3;
  while (u != -1) {
    printf ("%d <- ", u);
    u = parents[u];
  }
  printf ("\n");

  generic_list_destroy (paths);
  integer_graph_destroy (&graph);
  return EXIT_SUCCESS;
}
